<?php if(!defined('PLX_ROOT')) exit;
# Controle du token du formulaire
plxToken::validateFormToken($_POST);
$plugName = get_class($plxPlugin);
$predim = intval($plxAdmin->aConf['images_l' ]).'x'.intval($plxAdmin->aConf['images_h' ]);#param
$folderDefault = empty($plxAdmin->aConf['medias'])?$plxAdmin->aConf['images']:$plxAdmin->aConf['medias'];
$dBacks = (isset($_POST['clean']));
// string bytestostr(int $size)
// Returns a string that represents the amount of bytes in the most convenient unit (gb, mb, kb, or b)
function bytestostr($size){
	static $bytetypes = array('b', 'kb', 'mb', 'gb');
	foreach(array_reverse($bytetypes, true) as $power => $unit){
		$cursize = ($size / pow(1024, $power));
		if($cursize >= .1)break;
	}
	return substr($cursize, 0, 4)."&nbsp;{$unit}";
}
# Contrôle du dossier
if(!$dBacks AND isset($_POST['folder']) AND is_dir(PLX_ROOT . $_POST['folder'])) {
	$folder = PLX_ROOT . rtrim($_POST['folder'], DIRECTORY_SEPARATOR);

	$resize = $predim;
	if(!empty($_POST['resize'])) {
		if($_POST['resize']=='user') {
			$resize = array('width' => intval($_POST['user_w']), 'height' => intval($_POST['user_h']));
		} else {
			list($width,$height) = explode('x', $_POST['resize']);
			$resize = array('width' => $width, 'height' => $height);
		}
	}
	# memory
	$_SESSION[$plugName.'_mem'] = array(
	'folder'=>$_POST['folder'],
	'resize'=>$_POST['resize'],
	'user_w'=>$_POST['user_w'],
	'user_h'=>$_POST['user_h']
	);

	$plxPlugin->optimize($folder, $resize);
	$gain = $plxPlugin->size['o'] - $plxPlugin->size['n'];
	$clr = ($gain >= 0) ? 'green' : 'red';
	$msg = '<i style="color:'.$clr.'">'
	 .bytestostr($plxPlugin->size['o'])
	 .'&nbsp;&gt;&nbsp;'
	 .bytestostr($plxPlugin->size['n'])
	 .'&nbsp;('.$plxPlugin->getLang('L_GAIN').'&nbsp;'.bytestostr($gain) .')</i>';

	plxMsg::Info($plxPlugin->getLang('L_OPTIMIZED') .' : '. $msg);#$_SESSION['info']
	$_SESSION[$plugName]['msg'] = $msg;

	if(empty(error_get_last())){#si aucune erreur
		header('Location: plugin.php?p='.$plugName);#On redirige
		exit;
	}
}
#Y a t'il des backups?
$path = realpath(PLX_ROOT . rtrim($folderDefault, '/').'/../');#dossier data
$backs = $plxPlugin->seeTree($path);
$dBacks = ($dBacks AND $backs);
$root = realpath(PLX_ROOT) . DIRECTORY_SEPARATOR;#dossier racine
foreach($backs as $i => $dir){
	if(is_dir($dir) and preg_match('~\d{14}_'.$plugName.'~', $dir)){
		$backs[$i] = str_replace($root,'',$dir);
		if($dBacks)
			$backs[$i] .=  ' ' . $plxPlugin->getLang(($plxPlugin->delTree($dir)?'L_DELETED':'L_PRESENT'));
	}
}
#Nettoyer les sauvegardes
if($dBacks){
	$_SESSION['clean' . $plugName] = $backs;
	plxMsg::Info($plxPlugin->getLang('L_CLEANED'));#$_SESSION['info']
	header('Location: plugin.php?p='.$plugName);#On redirige
	exit;
}

if(!isset($_SESSION[$plugName.'_mem'])){#default memory
	$_SESSION[$plugName.'_mem'] = array(
	'folder'=>$folderDefault,
	'resize'=>$predim,
	'user_w'=>'',
	'user_h'=>''
	);
}
#inspiré de medias.php
?>
<h2 class="hide"><span class="hide"><?=$plugName?></span></h2>
<form id="form_<?=$plugName?>" class="inline-form" method="post">
	<?= plxToken::getTokenPostMethod() ?>
	<div class="grid">
		<div class="col sml-12 med-4 lrg-5 label-centered">
			<label for="id_folder">
				<?php $plxPlugin->lang('L_FOLDER') ?>&nbsp;:
			</label>
		</div>
		<div class="col sml-12 med-8 lrg-7">
			<?php plxUtils::printInput('folder', $_SESSION[$plugName.'_mem']['folder'], 'text'); ?>&nbsp;<a class="hint help">
					<span><?php $plxPlugin->lang('L_FOLDER_HELP') ?> "/"</span></a>
		</div>
		<div class="col sml-12 med-4 lrg-5">
			<ul class="unstyled-list">
				<li><?= L_MEDIAS_RESIZE ?>&nbsp;:&nbsp;</li>
				<?php # $img_redim from lib/config.php : #bep session resizememo to autochecked + user_[w|h]
					$lparm = '&nbsp;&nbsp;(<a href="parametres_affichage.php">'.L_MEDIAS_MODIFY.'</a>)';#lien param
					$img_redim[] = $predim;#ajoute la param configuré
					foreach($img_redim as $redim) {
						$checked = ($redim==$_SESSION[$plugName.'_mem']['resize'])?' checked="checked"':'';
						$link = ($redim==$predim)?$lparm:'';
						echo '<li><input type="radio"'.$checked.' name="resize" value="'.$redim.'" />&nbsp;'.$redim.$link.'</li>';
					}
					$checked = ('user'==$_SESSION[$plugName.'_mem']['resize'])?' checked="checked"':'';
				?>
				<li>
					<input type="radio"<?=$checked?> name="resize" value="user" />&nbsp;
					<input type="text" size="2" maxlength="4" name="user_w" value="<?=$_SESSION[$plugName.'_mem']['user_w']?>" />&nbsp;x&nbsp;
					<input type="text" size="2" maxlength="4" name="user_h" value="<?=$_SESSION[$plugName.'_mem']['user_h']?>" />
				</li>
			</ul>
		</div>
<?php if(!empty($_SESSION[$plugName])):?>
		<div class="col sml-12">
			<h2><?php
				$plxPlugin->lang('L_OPTIMIZED');
				echo ' : '. $_SESSION[$plugName]['msg'];
				unset($_SESSION[$plugName]['msg']);
			?></h2>
<?= implode('<br/>' . PHP_EOL, $_SESSION[$plugName]) ?>
		</div>
<?php unset($_SESSION[$plugName]);endif;
 if(!empty($_SESSION['clean' . $plugName])):?>
		<div class="col sml-12">
			<h2><?php $plxPlugin->lang('L_CLEANED') ?></h2>
<?= implode('<br/>' . PHP_EOL, $_SESSION['clean' . $plugName]) ?>
		</div>
<?php unset($_SESSION['clean' . $plugName]);endif;
 if($backs):
?>
		<div class="col sml-12">
			<h2>
				<?php $plxPlugin->lang('L_BACKUPS') ?>
				<input type="submit" name="clean" value="<?php $plxPlugin->lang('L_CLEAN') ?>" class="red" onclick="if(confirm('<?php $plxPlugin->lang('L_CLEAN') ?>?')){this.value='...';this.style.display='none';}else{return false;}" />
			</h2>
<?= implode('<br/>' . PHP_EOL, $backs) ?>
		</div>
<?php endif; ?>
	</div>
	<p class="in-action-bar no-margin sml-text-center med-text-left full-width">
		<input type="submit" name="<?=$plugName?>" value="<?php $plxPlugin->lang('L_OPTIMZ') ?>" onclick="if(confirm('<?php $plxPlugin->lang('L_OPTIMZ') ?>?')){this.value='...';this.style.display='none';}else{return false;}" />
	</p>
</form>
