<?php if(!defined('PLX_ROOT')) exit;
/**
 * PluXml Plugin	optimages * @author	sudwebdesign (#todo: Move funks in admin.php tool CLASS file)
 **/
class optimages extends plxPlugin {
	public $thumbs = '~\/.thumbs/~i';#No .thumbs Folders
	public $img_exts = '~\.(?<!tb\.)(jpe?g|png|gif|bmp|webp)$~i';#No .tb.ext #Negative look behind
	public $size = array('o' => 0, 'n' => 0);#size gain
	public $resize = array('width' => 800, 'height' => 600);
	public static $DEFAULT_PERMS = 0755;
	public function __construct($default_lang) {
		parent::__construct($default_lang);# appel du constructeur de la classe plxPlugin (obligatoire)
		if(defined('PLX_ADMIN')){
			# Autorisation d'acces à la configuration du plugin
			$this->setConfigProfil(PROFIL_ADMIN, PROFIL_MANAGER);
			# Autorisation d'accès à l'administration du plugin
			$this->setAdminProfil(PROFIL_ADMIN, PROFIL_MANAGER);
			#$this->addHook('hookname', 'plugfunk');
		}
	}
	/**
	 * Méthode qui lance les opérations
	 **/
	public function optimize($dir, $resize) {
		if(is_array($resize)) $this->resize = $resize;
		$_SESSION[__CLASS__] = array();

		$tmp = $dir . '_' . date('YmdHis') . '_' . __CLASS__;
		# Vérif : Renomme pour évité le pb de droit d'écriture de fichiers
		if(rename($dir, $tmp) and rename($tmp, $dir)){
			$this->copyr($dir, $tmp);
			rename($dir, $tmp . '_BACKUP');#Sauvegarde l'original
			rename($tmp, $dir);#devient l'original
		}
	}
	/**
	 * Méthode qui redimentionne une image si besoin ou copie le fichier
	 **/
	public function makeThumb($src, $dest) {
		if(!preg_match($this->img_exts, $src) or preg_match($this->thumbs, $src))
			return copy($src, $dest);

		set_time_limit(30);# au cas ou

		if(plxUtils::makeThumb($src, $dest, $this->resize['width'], $this->resize['height'], 80)){
			$o = getimagesize($src);
			$n = getimagesize($dest);
			$so = filesize($src);
			$sn = filesize($dest);

			if($so < $sn) {# Originale plus petite
				if(unlink($dest)) {
					if(copy($src, $dest)) {#Garde l'originale
						$n = $o;
						$sn = $so;
					}
				}
			}

			$this->size['o'] += $so;
			$this->size['n'] += $sn;
			$c = ($so >= $sn) ? 'green' : 'red';
			$_SESSION[__CLASS__][] = str_replace(PLX_ROOT,'',$src)
			 . ' <i style="color:'.$c.'">'
			 . $o[0] . 'x' . $o[1] . '&nbsp;(' . $so .'&nbsp;b)'
			 . '&nbsp;&gt;&nbsp;'
			 . $n[0] . 'x' . $n[1] . '&nbsp;(' . $sn .'&nbsp;b)'
			 . '</i>';
			return true;
		}
		return copy($src, $dest);#si makeThumb en erreur
	}
	/**
	 * Copy a file + optim img, or recursively copy a folder and its contents
	 * @author Aidan Lister <aidan@php.net>
	 * @version 1.0.1-gfm
	 * @link http://aidanlister.com/2004/04/recursively-copying-directories-in-php/
	 * @param       string   $src    Source path
	 * @param       string   $dest      Destination path
	 * @return      bool     Returns TRUE on success, FALSE on failure
	 */
	public function copyr($src, $dest) {
		if (is_link($src)) {// Check for symlinks
			return symlink(readlink($src), $dest);
		}
		if (is_file($src)) {// Simple copy for a file + optim
			#return copy($src, $dest);#origin
			return $this->makeThumb($src, $dest);#optimages or copy
		}
		if (!is_dir($dest)) {// Make destination directory
			mkdir($dest, self::$DEFAULT_PERMS);
		}
		$dir = dir($src);
		while (false !== $entry = $dir->read()) {// Loop through the folder
			if ($entry == '.' || $entry == '..') {// Skip pointers
				continue;
			}
			if($this->copyr("{$src}/{$entry}", "{$dest}/{$entry}")){// Deep copy directories
				@chmod("{$dest}/{$entry}", self::$DEFAULT_PERMS);//4 gfm
			}
		}
		$dir->close();// Clean up
		return true;
	}
	public $tree = array();#Return array of list recursively a directory tree
	public function seeTree($dir) {#TEP
		if(!is_readable($dir)) return $this->tree[] = "{$dir} Permission denied";
		$files = array_diff(scandir($dir), array('.','..'));
		foreach ($files as $file) {
			$tmp = "{$dir}/{$file}";
			if(is_dir("{$dir}/{$file}")) {
				if(strpos($tmp, '_'.__CLASS__.'_') !== FALSE) $this->tree[] = $tmp;
				else $this->seeTree($tmp);
			}
		}
		return $this->tree;
	}
	#try to delete recursively a tree : nbari at dalmp dot com : http://php.net/manual/en/function.rmdir.php#110489 & http://les.pages.perso.chez.free.fr/suppression-de-fichiers-et-dossiers-impossible.io
	public function delTree($dir) {#TEP
		if(!preg_match('~\d{14}_'.__CLASS__.'~', $dir)) return false;#protect
		$files = array_diff(scandir($dir), array('.','..'));
		foreach ($files as $file) {
			(is_dir("{$dir}/{$file}")) ? $this->delTree("{$dir}/{$file}") : unlink("{$dir}/{$file}");
		}
		$deleted = @rmdir($dir);// (effacement normal ailleurs que chez Free)
		if (is_dir($dir)) {// l'effacement a échoué
			$deleted = rename($dir,$dir.'.trash_me');// rename "spécial Free" rename empty folders to /.trash_me (effet de bord non garanti de rename)
		}
		return $deleted;
	}

	/**
	 * Méthode qui charge et combine le fichier de langue de l'aide du plugin (dossier lang/help) * @author	Thomas I
	 **/
	public function loadHelpLang() {
		$aLang = $this->loadLang(PLX_PLUGINS.__CLASS__.'/lang/help/'.$this->default_lang.'.php');
		$this->aLang = array_merge($this->aLang, $aLang);
	}
}#class optimages